package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ShowFirewallRuleDetailsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewShowFirewallRuleDetailsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ShowFirewallRuleDetailsLogic {
	return &ShowFirewallRuleDetailsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ShowFirewallRuleDetailsLogic) ShowFirewallRuleDetails(req *types.ShowFirewallRuleDetailsReq) (resp *types.ShowFirewallRuleDetailsResp, err error) {
	// todo: add your logic here and delete this line
	ShowFirewallRuleDetailsReq := &openstack.ShowFirewallRuleDetailsReq{}
	err = copier.CopyWithOption(ShowFirewallRuleDetailsReq, req, copier.Option{Converters: utils.Converters})
	ShowFirewallRuleDetailsResp, err := l.svcCtx.OpenstackRpc.ShowFirewallRuleDetails(l.ctx, ShowFirewallRuleDetailsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ShowFirewallRuleDetailsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ShowFirewallRuleDetailsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
